MODULE Windows;

IMPORT
  SYSTEM, Kernel;

CONST
  NULL*               = 0;

  STD_INPUT_HANDLE*   = -10;
  STD_OUTPUT_HANDLE*  = -11;
  STD_ERROR_HANDLE*   = -12; 

TYPE
  BOOL*               = LONGINT;
  ADDRESS*            = LONGINT;
  ATOM*               = INTEGER;
  HANDLE*             = ADDRESS;
  HMODULE*            = ADDRESS;
  HINSTANCE*          = ADDRESS;
  HGLOBAL*            = HANDLE;
  LPSTR*              = ADDRESS;

VAR
  AllocConsole- : PROCEDURE [WINAPI] (): BOOL;
  GetStdHandle- : PROCEDURE [WINAPI] (nStdHandle: LONGINT): HANDLE;
  WriteFile-    : PROCEDURE [WINAPI] (hFile: HANDLE; VAR lpBuffer: ARRAY [NOTAG] OF SYSTEM.BYTE; nNumberOfBytesToWrite: LONGINT; VAR lpNumberOfBytesWritten: LONGINT; lpOverlapped: SYSTEM.PTR): BOOL;
  ReadFile-     : PROCEDURE [WINAPI] (hFile: HANDLE; VAR lpBuffer: ARRAY [NOTAG] OF SYSTEM.BYTE; nNumberOfBytesToRead: LONGINT; VAR lpNumberOfBytesRead: LONGINT; lpOverlapped: SYSTEM.PTR): BOOL;

BEGIN
  IF Kernel.call = 0 THEN
    INC(Kernel.call);
    Kernel.Init();
  ELSIF Kernel.ExitProc # NIL THEN
    Kernel.Shutdown(0);
  END;
END Windows.
