MODULE Console;

IMPORT
  Windows, SYSTEM;

VAR  
  hin, hout: Windows.HANDLE;

PROCEDURE Length*(str:ARRAY OF CHAR): LONGINT;
VAR
  n,i,c:LONGINT;
BEGIN
  n:=LEN(str);
  i:=0;
  WHILE (i<n) & (str[i]>0X) DO INC(i); END;
  RETURN i;
END Length;

PROCEDURE WriteString*(str:ARRAY OF CHAR);
VAR
  n,i,c:LONGINT;
BEGIN
  n:=Length(str);

  i:=0;
  WHILE (i<n) DO
    c:=ORD(str[i]);
    IF    (c>=192) & (c<=239) THEN c:=c-64;
    ELSIF (c>=240) & (c<=255) THEN c:=c-16;
    ELSIF (c=168)             THEN c:=240;
    ELSIF (c=184)             THEN c:=241;
    END;
    str[i]:=CHR(c);
    INC(i);
  END;

  SYSTEM.PUTREG(0, Windows.WriteFile(hout, str, n, n, NIL));
END WriteString;

PROCEDURE Write*(ch: CHAR);
VAR
  str: ARRAY 2 OF CHAR;
BEGIN
  str[0] := ch;
  str[1] := 0X;
  WriteString(str);
END Write;

PROCEDURE WriteLn*();
VAR
  str: ARRAY 2 OF CHAR;
BEGIN
  str[0] := 0DX;
  str[1] := 0AX;
  WriteString(str);
END WriteLn;

PROCEDURE ReadString*(VAR str:ARRAY OF CHAR);
VAR
  n,i,c:LONGINT;
BEGIN
  n:=LEN(str);  
  SYSTEM.PUTREG(0, Windows.ReadFile(hin, str, n, n, NIL));
  str[n-2]:=0X; (* - 0AX 0DX *)
  
  i:=0;
  WHILE i<n DO
    c:=ORD(str[i]);
    IF    (c>=192) & (c<=239) THEN c:=c+16;
    ELSIF (c=240)             THEN c:=168;
    ELSIF (c=241)             THEN c:=184;
    ELSIF (c=168)             THEN c:=232;
    END;
    str[i]:=CHR(c);
    INC(i);
  END;

END ReadString;

BEGIN
  hin := Windows.GetStdHandle(Windows.STD_INPUT_HANDLE);
  hout:= Windows.GetStdHandle(Windows.STD_OUTPUT_HANDLE);
END Console.
